//////////////////////////////////////////////////////////////////////////////
//
//  Xilinx, Inc. 2002                 www.xilinx.com
//
//  XAPP 291 - Self Addressing FIFO
//
//////////////////////////////////////////////////////////////////////////////
//
//  File name :       incrementer_10bit.v
//
//  Description :     10-bit incrementer
//
//  Date - revision : December 11th 2002 - v 1.2
//
//  Author :          NJS
//
//  Contact : e-mail  hotline@xilinx.com
//            phone   + 1 800 255 7778
//
//  Disclaimer: LIMITED WARRANTY AND DISCLAMER. These designs are
//              provided to you "as is". Xilinx and its licensors make and you
//              receive no warranties or conditions, express, implied,
//              statutory or otherwise, and Xilinx specifically disclaims any
//              implied warranties of merchantability, non-infringement,or
//              fitness for a particular purpose. Xilinx does not warrant that
//              the functions contained in these designs will meet your
//              requirements, or that the operation of these designs will be
//              uninterrupted or error free, or that defects in the Designs
//              will be corrected. Furthermore, Xilinx does not warrantor
//              make any representations regarding use or the results of the
//              use of the designs in terms of correctness, accuracy,
//              reliability, or otherwise.
//
//              LIMITATION OF LIABILITY. In no event will Xilinx or its
//              licensors be liable for any loss of data, lost profits,cost
//              or procurement of substitute goods or services, or for any
//              special, incidental, consequential, or indirect damages
//              arising from the use or operation of the designs or
//              accompanying documentation, however caused and on any theory
//              of liability. This limitation will apply even if Xilinx
//              has been advised of the possibility of such damage. This
//              limitation shall apply not-withstanding the failure of the
//              essential purpose of any limited remedies herein.
//
//  Copyright  2002 Xilinx, Inc.
//  All rights reserved
//
//////////////////////////////////////////////////////////////////////////////
//
`timescale 1 ps / 1ps

module incrementer_10bit (
	ip,						// input bus
	op);						// output bus

input 	[9:0] 	ip;

output 	[9:0] 	op;

wire 	[8:0] 	c ;					// set to input bus size - 1
wire 	[9:0] 	int ;					// set to input bus size

assign op = int ;

assign int[9] = (c[8] == 1'b1) ? ip[8] : ip[9] ;	// 2 MSBs of the incrementer count in Gray code
assign int[8] = (c[8] == 1'b1) ? ~ip[9] : ip[8] ;

assign c = {1'b0, (ip[7:0] + 1)}; 			// the rest count binary
assign int[7:0] = c[7:0];				// creates carry bit at c(size-2)

endmodule

